#ifndef __CSV_H_INCLUDED
#define __CSV_H_INCLUDED 1

#include <iostream>
#include <string.h>

namespace VIVER {


class CSV : public std::iterator< std::input_iterator_tag, int> {
public:
	explicit CSV(const char* data);				// throw(bad_alloc)
	~CSV();							// throw()
	const char* get(void) const;				// throw()
	const char* operator* (void) const { return get(); }	// throw()
	CSV& operator++ (void);					// throw()
	bool end(void) const;					// throw()
public:
	const char* data(void) const { return m_data; }		// throw()
private:
	char* m_data;
	char* m_pos_begin;			// 終端に達したらNULL
	char* m_pos_end;			// 終端に達したらNULL
private:
	CSV();					// デフォルトコンストラクタを禁止
};


}  // namespace VIVER

#endif /* csv.h */
