#include "meta.h"
#include <iostream>

namespace RUNES {

namespace Manager {


// コンストラクタ
Meta::Meta()
{}


// デストラクタ
Meta::~Meta()
{}


// public:
void Meta::show() const
{
	std::cout << "Location:  " << m_location << "\n";
	std::cout << "Checksum:  " << m_checksum << "  (" << m_checksum_type << ")\n";
	std::cout << "Size:      " << m_size << std::endl;
	// XXX: bundle_info
}

const std::string& Meta::getLocation(void) const
{
	return m_location;
}

uint64_t Meta::getSize(void) const
{
	return m_size;
}

Meta::checked_t Meta::checkSum(void) const
{
	// XXX: 未実装
	return NOTSPECIFIED;
}

void Meta::clear(void)
{
	m_location = "";
	m_checksum = "";
	m_checksum_type = "";
	m_size = 0;
}


}  // namespace Manager

}  // namespace RUNES

